#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

//1 papir, 2 kamen, 3 makaze
typedef struct stat_s{
	int oruzje,brpobeda,brporaza;
	}STAT;
	
typedef struct igrac_s{
	int oruzje,brpobeda,brporaza;
	}IGRAC;
	
void SumStat(STAT *in,STAT *inout,int *len,MPI_Datatype t){
		int i=0;
		for(i=0;i<*len;i++){
			inout->brpobeda+=in->brpobeda;
			inout->brporaza+=in->brporaza;
			}
	}
	
int koJeBolji(int prvi,int drugi){
		if(prvi == 1 && drugi==2) return 1;
		if(prvi == 1 && drugi==3) return 2;
		if(prvi == 2 && drugi==1) return 2;
		if(prvi == 2 && drugi==3) return 1;
		if(prvi == 3 && drugi==1) return 1;
		if(prvi == 3 && drugi==2) return 2;
		else return 0;
	}
int main(int argc, char *argv[]){
	int i,j,rank,size;
	int m,n,k,brojac;
	MPI_Init(&argc,&argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
	MPI_Comm_size(MPI_COMM_WORLD, &size);
	MPI_Datatype oldtype[1],stattype,igractype;
	MPI_Aint extent;
	MPI_Type_extent(MPI_INT,&extent);
	MPI_Aint offset[1];
	int blocknumber[1];
	oldtype[0]=MPI_INT;
	offset[0]=0;
	blocknumber[0]=3;
	MPI_Type_struct(1,blocknumber,offset,oldtype,&stattype);
	MPI_Type_struct(1,blocknumber,offset,oldtype,&igractype);
	MPI_Type_commit(&stattype);
	MPI_Type_commit(&igractype);
	MPI_status status;
	int svakoPo=n/size;
	if(rank == 0){
		scanf("%d %d",&n,&m);
		scanf("%d",&k);
		}
	brojac=k;
	MPI_Barrier(MPI_COMM_WORLD);
	MPI_Bcast(&m,1,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Bcast(&k,1,MPI_INT,0,MPI_COMM_WORLD);
	IGRAC **mojamatrica,**staramatrica;
	STAT rezultat[3][k];
	mojamatrica=(IGRAC**)malloc((svakoPo+1)*sizeof(IGRAC*));
	
	for(i=0;i<n;i++){
		mojamatrica[i]=(IGRAC*)malloc(n*sizeof(IGRAC));
		}
		
	staramatrica=(IGRAC**)malloc((svakoPo+1)*sizeof(IGRAC*));
	for(i=0;i<n;i++){
		staramatrica[i]=(IGRAC*)malloc(n*sizeof(IGRAC));
		}
		
	srand(rank+time(NULL));
	for(i=0;i<svakoPo;i++){
		for(j=0;j<m;j++){
			mojamatrica[i][j].oruzje=staramatrica[i][j].oruzje=rand()%3;
			mojamatrica[i][j].brpobeda=staramatrica[i][j].brpobeda=0;
			mojamatrica[i][j].brporaza=staramatrica[i][j].brporaza=0;
			}
		}
	
	while(brojac > 0){
		if(rank==0){
			MPI_Recv(&staramatrica[svakoPo][0],n,igractype,id+1,0,MPI_COMM_WORLD,&status);
			}
			else if(rank== size-1) MPI_Send(staramatrica[0][0],n,igractype,id-1,0,MPI_COMM_WORLD);
			else {
				MPI_Send(staramatrica[0][0],n,igractype,id-1,0,MPI_COMM_WORLD);
				MPI_Recv(&staramatrica[svakoPo][0],n,igractype,id+1,0,MPI_COMM_WORLD,&status);
				}
				
		for(i=0;i<svakoPo;i++){
			for(j=0;j<m;j++){
				mojamatrica[i][j].oruzje=staramatrica[i][j].oruzje=rand()%3;
				}
			}
			
			
		for(i=0;i<svakoPo;i++){
			for(j=0;j<m;j++){
				if(i==0){
					if(j==0){

						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++ ;}
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						}
					if(j>0){
					if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j-1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++;}
					else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
					if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
					else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
					if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
					else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
					if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j-1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
					else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
					if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
					else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						}
					}
				else {
						if(j==0){

						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						}
					if(j>0){
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j-1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
						else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						if(i<svakoPo-1){
							if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
							else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
							if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j-1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
							else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
							if(koJeBolji(mojamatrica[i][j].oruzje,mojamatrica[i+1][j+1].oruzje) == 1) {mojamatrica[i][j].brpobeda++; rezultat[mojamatrica[i][j].oruzje][brojac].brpobeda++; }
							else {mojamatrica[i][j].brporaza++; rezultat[mojamatrica[i][j].oruzje][brojac].brporaza++;}
						}
						}
					}
				}
			}
			for(i=0;i<svakoPo;i++){
			for(j=0;j<m;j++){
				staramatrica[i][j].oruzje=mojamatrica[i][j].oruzje;
				staramatrica[i][j].brpobeda=mojamatrica[i][j].brpobeda;
				staramatrica[i][j].brporaza=mojamatrica[i][j].brporaza;
				}
			}
			brojac--;
		}
		
		STAT resenje;
		
		
	
	MPI_Op funk;
	MPI_Op_create((MPI_User_Function*)SumStat,&funk);
	MPI_Reduce(&rezultat,&resenje,1,stattype,funk,0,MPI_COMM_WORLD);
	
	
	
	MPI_Finalize();
}
