#include<stdio.h>
#include<stdlib.h>
#include<mpi.h>

typedef struct igrac
{
	int oruzje; //0-papir, 1-kamen, 2-makaze
	int br_pobeda;
	int br_poraza;
} Igrac;

typedef struct stat
{
	int oruzje;
	int br_pobeda;
	int br_poraza;
} Stat;


void SumStat(Stat *s1, Stat *s2, int *len, MPI_Datatype *type)
{
	int i;
	for(i=0;i<*len;i++)
	{
		*s2->br_pobeda+=*s1->br_pobeda;
		*s2->br_poraza+=*s1->br_poraza;
		s1++;
		s2++;
	}
}

int main(int argc, char *argv[])
{
	MPI_Init(&argc,&argv);
	MPI_COMM comm;
	MPI_COMM_STATUS &status;
	
	
	MPI_Datatype struktura;
	int duzina[1] = {3};
	MPI_Datatype sadrzi[1]={MPI_INT};
	MPI_Aint razmak[1]={0}; //krece od 0
	
	MPI_Type_struct(1,duzina,razmak,sadrzi,&struktura);
	MPI_Type_commit(&struktura);
	
	int id;
	int br_proc;
	MPI_Comm_rank(MPI_COMM_WORLD,&id);
	MPI_comm_size(MPI_COMM_WORLD,&br_proc);
	
	
	int m=100,n=100;
	Igrac tabla[m*n];
	
	if(id==0)
	{
		srand(id*2+5);	
		for(int i=0;i<n*m;i++)
		{
			int oruzje = (rand()%10)%4;	
			Igrac ig;
			ig.oruzje=oruzje;
			ig.br_pobeda=0;
			ig.br_poraza=0;
			tabla[i]=ig;
		}
	}
	
	/*
	 *potrebno je sada izdeliti matricu, tj.niz izmedju procesa
	 * 
	 * 0 proces u svoju ghost kolonu(krajnju desnu) prima od procesa 1 prvu levu kolonu(neghost),
	 * a salje 1om procesu svoju krajnju desnu kolonu u njegovu levu ghost
	 * 
	 * poslednji proces svoju krajnju levu neghost kolonu
	 * salje pretposlednjem procesu u njegovu ghost kolonu,
	 * a od njega prima krajnju desnu neghost kolonu u svoju levu ghost
	 * 
	 * ostali procesi procesu ispred sebe salju svoju levu neghost kolonu u njihovu
	 * desnu ghost i procesu ispred sebe salju svoju krajnju desnu kolonu
	 * u njihovu levu ghost, a primaju njihovu kraju levu neghost u svoju desnu ghost
	 * 
	 * pazi se da ne dodje do deadlock-a pri send i recv,
	 * tako sto ako 0. salje 1. pa prima od njega, onda 1. prvo prima od 0. pa salje
	 * 
	 *
	 * nakon zavrsetka radi se redukcija
	 * 
	 * znam postupak kako se radi, ali nisam stigla da izvezbam dovoljno...
	 * nadam se da ce sada biti dovoljno za uslov, jer mi fali 1 bod...
	 * */
	
	MPI_Op operacija;
	MPI_Op_create((MPI_User_function *)SumStat, 0, &operacija);
	MPI_Reduce(nizS, nizP, 1, Stat, operacija, 0, MPI_COMM_WORLD);
	MPI_Finalize();
	return 0;
}
