#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

main(int argc,char *argv[]){
	int id,size,n,i;
	double *x,*y,*mojeX,*mojeY;
	MPI_Status status;
	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&size);
	MPI_Comm_rank(MPI_COMM_WORLD,&id);
	if(id==0){
		//ucitavanje n
		FILE *f=fopen("ulaz.dat","r");
		fscanf(f,"%d",&n);
		//rezervisanje memorije za nizove
		x=(double *)malloc(n*sizeof(double));
		y=(double *)malloc(n*sizeof(double));
		for(i=0;i<n;i++){
				fscanf(f,"%lf %lf",&x[i],&y[i]);
			}
		//saljem duzinu nizova, nizove, i prebacujem ih u mojeX,mojeY
		for(i=1;i<size;i++) MPI_Send(&n,1,MPI_INT,i,10,MPI_COMM_WORLD);
		mojeX=(double *)malloc(n*sizeof(double));
	    mojeY=(double *)malloc(n*sizeof(double));
		for(i=0;i<n;i++){
		      mojeX[i]=x[i];
		      mojeY[i]=y[i];	
			}
		for(i=1;i<size;i++){
			MPI_Send(x,n,MPI_DOUBLE,i,15,MPI_COMM_WORLD);
			MPI_Send(y,n,MPI_DOUBLE,i,15,MPI_COMM_WORLD);
			}
		}
	else{
		//prihvatanje duzine nizova, prihvatanje nizova od strane ne root procesa
		 MPI_Recv(&n,1,MPI_INT,0,10,MPI_COMM_WORLD,&status);
		 mojeX=(double *)malloc(n*sizeof(double));
	     mojeY=(double *)malloc(n*sizeof(double));
		 MPI_Recv(mojeX,n,MPI_DOUBLE,0,15,MPI_COMM_WORLD,&status);
		 MPI_Recv(mojeY,n,MPI_DOUBLE,0,15,MPI_COMM_WORLD,&status);
		 }
     int j,k,s;
     double povrsina,max=0,*koordinateX,*koordinateY;
     //nizovi za koordinate koje imaju najvecu povrsinu
     koordinateX=(double *)malloc(4*sizeof(double));
     koordinateY=(double *)malloc(4*sizeof(double));
	 for(i=id;i<n;i+=size){
		for(j=id+1;j<n;j++){
			for(k=j+1;k<n;k++){
				for(s=k+1;s<n;s++){
					povrsina=1.0/2.0*(mojeY[i]*(mojeX[s]-mojeX[j])+mojeY[j]*(mojeX[i]-mojeX[k])+mojeY[k]*(mojeX[j]-mojeX[s])+mojeY[s]*(mojeX[k]-mojeX[i]));
				//	printf("Ja sam id: %d\t i racunam povrsinu %.2lf\n",id,povrsina);
					if(povrsina>max){
						//cuvanje najvece povrsine i njihove koordinate
						koordinateX[0]=mojeX[i];
						koordinateX[1]=mojeX[j];
						koordinateX[2]=mojeX[k];
						koordinateX[3]=mojeX[s];
						koordinateY[0]=mojeY[i];
						koordinateY[1]=mojeY[j];
						koordinateY[2]=mojeY[k];
						koordinateY[3]=mojeY[s];
						max=povrsina;
					}
				}
			
			}
		}
	}
		if(id!=0){
			//slanje podataka root procesu, maximalna povrisna, id , i koordinate
			MPI_Send(&id,1,MPI_INT,0,10,MPI_COMM_WORLD);
			MPI_Send(&max,1,MPI_DOUBLE,0,10,MPI_COMM_WORLD);
			MPI_Send(koordinateX,4,MPI_DOUBLE,0,15,MPI_COMM_WORLD);
			MPI_Send(koordinateY,4,MPI_DOUBLE,0,15,MPI_COMM_WORLD);
			}
		else if(id==0){
			double pomocno,*konacnoX,*konacnoY,*primX,*primY;
			int brojac=0,flag=0,lokalniID,j;
			//nizovi za konacne koordinate
			konacnoX=(double *)malloc(16*sizeof(double));
			konacnoY=(double *)malloc(16*sizeof(double));
			//root proces smesta svoje podatke u konanci niz
			for(i=0;i<4;i++){
				konacnoX[i]=koordinateX[i];
				konacnoY[i]=koordinateY[i];
				}
			//nizovi za prihvatanje koordinata
			primX=(double *)malloc(4*sizeof(double));
			primY=(double *)malloc(4*sizeof(double));
			//prihvatanje podataka
			for(j=1;j<size;j++){
			MPI_Recv(&lokalniID,1,MPI_INT,j,10,MPI_COMM_WORLD,&status);
			MPI_Recv(&pomocno,1,MPI_DOUBLE,j,10,MPI_COMM_WORLD,&status);
			if(pomocno>max){
				max=pomocno;
				flag=lokalniID;
				}
			MPI_Recv(primX,4,MPI_DOUBLE,j,15,MPI_COMM_WORLD,&status);
			MPI_Recv(primY,4,MPI_DOUBLE,j,15,MPI_COMM_WORLD,&status);
			for(i=0;i<4;i++){
				konacnoX[lokalniID*4+i]=primX[i];
				konacnoY[lokalniID*4+i]=primY[i];
				}
			}
			//ispis resenje
			printf("najveca povrsina je %.2lf\n",max);
			printf("Koordinate\n");
			for(i=lokalniID*4;i<(lokalniID*4+4);i++){
				printf("A(%.2lf\t , %.2lf)\n",konacnoX[i],konacnoY[i]);
				}
			}
	
	MPI_Finalize();
	}
