#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

typedef struct ig{
	int brojP;
	int brojPP;
} Igrac;

typedef struct s{
	int oruzje;
	int brojP;
	int brojPP;
} Stat;

int pobedio(int prvi, drugi){
	if(prvi == 0 && drugi = 1) return 1;
	if(prvi == 1 && drugi = 2) return 1;
	if(prvi == 2 && drugi = 0) return 1;
	return 0;
}
void plusStat(Stat *in, Stat *inout, int *len, MPI_Datatype *type)
{
	int i;
	for (i=0; i<*len; i++)
	{
		*inout->brojP = *in->brojP + *inout->brojP;
		*inout->brojPP = *in->brojPP + *inout->brojPP;
		
		in++;
		inout++;
	}
}


int main(int argc, char *argv[]){
	int id, np, brojKrugova, brojVrsta, brojKolona, kolone, i, j, pom, m;
	MPI_Datatype strukturaStat, strukturaIgrac;
	MPI_Status status;
	MPI_Init(&argc, &argv);
	MPI_Comm_rank(MPI_COMM_WORLD, &id);
	MPI_Comm_size(MPI_COMM_WORLD, &np);
	MPI_Rank_comm();
	
	int duzine[1] = {3};
	int razmak[1] = {0};
	MPI_Datatype stari = {MPI_INT};
	MPI_Aint razmaci;
	MPI_Type_extent(MPI_INT, &razmaci); 
	MPI_Type_struct (1, duzine, razmaci, &stari, &strukturaStat);
	MPI_Type_commit(strukturaStat);
	
	duzine[0] = 2;
	razmak[0] = 0;
	MPI_Type_struct (1, duzine, razmaci, &stari, &strukturaIgrac);
	MPI_Type_commit(strukturaIgrac);
	
	if(id == 0){
		scanf("%d%d%d", &brojVrsta, &brojKolona, &brojKrugova);
	}
	MPI_Broadcast(brojVrsta, 1, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Broadcast(brojKolona, 1, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Broadcast(brojKrugova, 1, MPI_INT, 0, MPI_COMM_WORLD);

	kolone = brojKolona/np +2;
	
	int *matrica = (int *)malloc(sizeof(int)*brojVrsta*kolone);
	Igrac *matricaIgraca = (Igrac *)malloc(sizeof(Igrac * brojVrsta * kolone);
	
	for (i = 0; i < brojVrsta; i++)
	{
		for (j = 0; j < kolone; j++)
		{
			matrica[i*kolone+j] = 0;
			matricaIgraca[i*kolone+j].brojP = 0;
			matricaIgraca[i*kolone+j].brojPP = 0;
		}
	}
	
	srand(time(NULL)*id);
	
	Stat papir, kamen, makaze;
	papir.oruzje = 0; papir.brojP = 0; papir.brojPP = 0;
	kamen.oruzje = 1; kamen.brojP = 0; kamen.brojPP = 0;
	makaze.oruzje = 2; makaze.brojP = 0; makaze.brojPP = 0;
	
	MPI_Op myop;
	MPI_Op_create(plusStat, 1, myop);
	
	int pom 1;
	if(id == 0){
		printf("Krug \t\t Papir \t\t Kamen \t\t Makaze \n");
	}
	while(brojKrugova > 0){		
		id( id != 0){	
			papir.oruzje = 0; papir.brojP = 0; papir.brojPP = 0;
			kamen.oruzje = 1; kamen.brojP = 0; kamen.brojPP = 0;
			makaze.oruzje = 2; makaze.brojP = 0; makaze.brojPP = 0;
		}
		
		for (i = 0; i < brojVrsta; i++){
			for (j = 0; j < kolone; j++)
				{
					matrica[i*kolone+j] = (int)rand()%3;
				}
		}
		
		if(id != np -1){
			MPI_Send(matrica[kolone-2], brojVrsta, MPI_INT, id+1, 10, MPI_COMM_WORLD);
		}
		if(id > 0){
			MPI_Recv(matrica[0], brojVrsta, MPI_INT, id-1, 10, MPI_COMM_WORLD, status);
			MPI_Send(matrica[1], brojVrsta, MPI_INT, id-1, 10, MPI_COMM_WORLD);
		}
		if(id != np -1){
			MPI_Send(matrica[kolone-1], brojVrsta, MPI_INT, id+1, 10, MPI_COMM_WORLD);
		}
		
		for (i = 0; i < brojVrsta; i++)
		{
			for (j = 0; j < kolone; j++)
				{
					//gore
					if(i > 0){
						if(pobedio(matrica[i*kolone+j], matrica[(i-1)*kolone+j)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					}
					if(i > 0 && j > 0){
						if(pobedio(matrica[i*kolone+j], matrica[(i-1)*kolone+j-1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
					if(i > 0 && j < kolone - 1){
						if(pobedio(matrica[i*kolone+j], matrica[(i-1)*kolone+j+1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
					//dole
					if(i < brojVrsta){
						if(pobedio(matrica[i*kolone+j], matrica[(i+1)*kolone+j)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					}
					if(i < brojVrsta && j > 0){
						if(pobedio(matrica[i*kolone+j], matrica[(i+1)*kolone+j-1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
					if(i < brojVrsta && j < kolone - 1){
						if(pobedio(matrica[i*kolone+j], matrica[(i+1)*kolone+j+1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
					//sa strana
					if( j > 0){
						if(pobedio(matrica[i*kolone+j], matrica[i*kolone+j-1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
					if(j < kolone - 1){
						if(pobedio(matrica[i*kolone+j], matrica[(i-1)*kolone+j+1)){
							matricaIgraca[i*kolone+j].brojP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojP++;
						}
						else{
							matricaIgraca[i*kolone+j].brojPP++;
							if(matrica[i*kolone+j] == 0)
								papir.brojPP++;
							else if(matrica[i*kolone+j] == 1)
								kamen.brojPP++;
							else if(matrica[i*kolone+j] == 2)
								makaze.brojPP++;
						}
					} 
				}//krajj
		}//kraji
		
		MPI_Reduce(&papir, &papir, 1, strukturaStat, myop, 0, MPI_COMM_WORLD);
		MPI_Reduce(&kamen, &kamen, 1, strukturaStat, myop, 0, MPI_COMM_WORLD);
		MPI_Reduce(&makaze, &makaze, 1, strukturaStat, myop, 0, MPI_COMM_WORLD);
		
		if(id == 0){
			printf("%d \t\t %d \t\t %d \t\t %d \n", pom, papir.brojP, kamen.brojP, makaze.brojP);
		}
		
		pom++;
		brojKrugova--;
	}
	
	int imax = 0; max = 0; jmax = 0;
	for (i = 0; i < brojVrsta; i++)
	{
		for (j = 0; j < kolone; j++)
			{
				if(matricaIgraca[i*kolone+j].brojP > max){
					max = matricaIgraca[i*kolone+j].brojP;
					imax = i*kolone;
					jmax = j;
				}
			}
	}
	int imaxevi[np];
	int jmaxevi[np];
	int maxevi[np];
	
	MPI_Gather (max, 1, MPI_INT, maxevi, np, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Gather (imax 1, MPI_INT, imaxevi, np, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Gather (jmax 1, MPI_INT, jmaxevi, np, MPI_INT, 0, MPI_COMM_WORLD);
	
	imax = 0; max = 0; jmax = 0;
	if(id == 0){
		for (i = 0; i < np; i++)
		{
			if(maxevi[i] > max){
				max = maxevi[i];
				imax = imaxevi[i];
				jmax = jmaxevi[i];
			}
		}
		printf("Igrac sa najvise pobeda je [%d][%d] \n", imax, jmax);
	}
	
}
