#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define gornja(id,np,n) (id*n/np);

typedef struct s
{
	int oruzje;
	int br_pobeda;
	int br_poraza;
}stat;

typedef struct ig
{
	int x, y;
	int oruzje;
	int br_pobeda;
	int br_poraza;
}igrac;

int pobedio(int or1, int or2, stat *statistika)
{
	if(or1==0 && or2==1) {statistika[0].br_pobeda++;return 1;}
	if(or1==0 && or2==2) {statistika[2].br_pobeda++;return 2;}
	if(or1==1 && or2==2) {statistika[1].br_pobeda++;return 1;}
}

void igrajte(int i1, int i2, igrac *igraci, stat *statistika)
{
	int p = pobedio(igraci[i1].oruzje,igraci[i2].oruzje, statistika);
	switch (p)
	{
		case 1:
			igraci[i1].br_pobeda++;
			igraci[i2].br_poraza++;
			break;
		case 2:
			igraci[i2].br_pobeda++;
			igraci[i1].br_poraza++;
			break;
	}
	
}

void SumStat(stat *stat2, stat *stat1, int *len, MPI_Datatype *type)
{
	int i;
	for (i = 0; i < *len; i++)
	{
		if(stat1[i].oruzje==stat2[i].oruzje) stat2[i].br_pobeda+=stat1[i].br_pobeda;
		stat1++;
		stat2++;
	}
	
}

int main(int argc, char *argv[])
{
	int id, np, M,N,K, vrsta, kolona, i,j, korak=0;
	MPI_Status status;
	
	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD, &np);
	MPI_Comm_rank(MPI_COMM_WORLD, &id);
	
	if(id==0)
	{
		scanf("%d%d%d", &M,&N,&K);		
	}
	MPI_Bcast (&M, 1, MPI_INT, 0, MPI_COMM_WORLD);	
	MPI_Bcast (&N, 1, MPI_INT, 0, MPI_COMM_WORLD);
	MPI_Bcast (&K, 1, MPI_INT, 0, MPI_COMM_WORLD);
	
	vrsta = M;
	kolona = N/np +2;
	
	igrac *igraci = (igrac *)malloc((vrsta*kolona)*sizeof(igrac));
	stat * statistika = (stat *)malloc(3*sizeof(stat));
		
	statistika[0].oruzje = 0;statistika[0].br_pobeda = 0;statistika[0].br_poraza = 0;
	statistika[1].oruzje = 1;statistika[1].br_pobeda = 0;statistika[1].br_poraza = 0;
	statistika[2].oruzje = 2;statistika[1].br_pobeda = 0;statistika[1].br_poraza = 0;
	
	for (i = 0; i < vrsta; i++)
	{
		for (j = 1; j < kolona-1; j++)
		{
			igraci[i*kolona+j].oruzje = (int)(rand()%3);
			igraci[i*kolona+j].br_pobeda = 0;
			igraci[i*kolona+j].br_poraza = 0;
			igraci[i*kolona+j].x = i;igraci[i*kolona+j].y = j;
		}		
	}
	
	for (i = 0; i < vrsta; i++)
	{
		igraci[i*kolona].oruzje = -1;igraci[i*kolona+kolona-1].oruzje = -1;
		igraci[i*kolona].br_pobeda = -1;igraci[i*kolona+kolona-1].br_pobeda = -1;
		igraci[i*kolona].br_poraza = -1;igraci[i*kolona+kolona-1].br_poraza = -1;
		igraci[i*kolona].x = -1;igraci[i*kolona].y = -1;igraci[i*kolona+kolona-1].x = -1;igraci[i*kolona+kolona-1].y = -1;
	}
	
	MPI_Datatype structIgrac, structStat, tipovi, kolonaIgrac;
	MPI_Aint intidzer, odakle;
	MPI_Type_extent(MPI_INT, &intidzer);
	odakle = 0; tipovi = MPI_INT;
	int koliko1 = 3, koliko2=5;
	MPI_Type_struct(1,&koliko1,&odakle,&tipovi, &structStat);
	MPI_Type_commit(&structStat);
	MPI_Type_struct(1,&koliko2, &odakle, &tipovi, &structIgrac);
	MPI_Type_commit(&structIgrac);		
	MPI_Type_vector(vrsta, 1, kolona, structIgrac, &kolonaIgrac);
	
	MPI_Op mojaRedukcija;
	MPI_Op_create(SumStat, 1, &mojaRedukcija);
	
	stat *globalStat = (stat *)malloc(3*sizeof(stat));
	
	while(korak<=K)
	{
		if(id!=np-1)
		{
			MPI_Send(&igraci[kolona-2], 1, kolonaIgrac, id+1, 10, MPI_COMM_WORLD);
		}
		if(id!=0)
		{
			MPI_Recv(&igraci[0], 1, kolonaIgrac,id-1, 10, MPI_COMM_WORLD, &status);
			MPI_Send(&igraci[1], 1, kolonaIgrac, id-1, 20, MPI_COMM_WORLD);
		}
		if(id!=np-1)
		{
			MPI_Recv(&igraci[kolona-1], 1, kolonaIgrac,id+1, 20, MPI_COMM_WORLD, &status);
		}	
		int trenutan = -1, pobednik=-1;
		for (i = 0; i < vrsta; i++)
		{
			for (i = 1; i < kolona-1; i++)
			{
				trenutan = i*kolona+j;
				if(igraci[trenutan-1].oruzje!=-1)
					igrajte(trenutan, trenutan-1,igraci, statistika);						
				if(igraci[trenutan+1].oruzje!=-1)
					igrajte(trenutan, trenutan+1,igraci, statistika);						
				if(igraci[trenutan-kolona].oruzje!=-1)
					igrajte(trenutan, trenutan-kolona,igraci, statistika);						
				if(igraci[trenutan+kolona].oruzje!=-1)
					igrajte(trenutan, trenutan+kolona,igraci, statistika);						
				if(igraci[trenutan-kolona+1].oruzje!=-1)
					igrajte(trenutan, trenutan-kolona+1,igraci, statistika);						
				if(igraci[trenutan-kolona-1].oruzje!=-1)
					igrajte(trenutan, trenutan-kolona-1,igraci, statistika);						
				if(igraci[trenutan+kolona+1].oruzje!=-1)
					igrajte(trenutan, trenutan+kolona+1,igraci, statistika);
				if(igraci[trenutan+kolona-1].oruzje!=-1)
					igrajte(trenutan, trenutan+kolona-1,igraci, statistika);
			}
		}
		
		for (i = 0; i < np; i++) {globalStat[i].oruzje=i;globalStat[i].br_pobeda=0;globalStat[i].br_poraza=0;}
		
		MPI_Reduce(statistika, globalStat, 1, structStat, mojaRedukcija,0, MPI_COMM_WORLD);
		if(id==0)
		{
			printf("Korak=%d, pobeda:\n", korak);			
			printf("papir=%d, kamen=%d, makaze=%d\n",globalStat[0].br_pobeda, globalStat[1].br_pobeda,globalStat[2].br_pobeda);			
		}
		
		korak++;	
	}//while
	
	//prebaci u globalne koordinate:
	for (i = 0; i < vrsta; i++)
	{
		for (j = 1; j < kolona-1; j++)
		{
			igraci[i*kolona+j].y = id*kolona+j-1;
		}
		
	}
	
	igrac max=igraci[0];
	for (i = 1; i < vrsta*kolona; i++)
	{
		if(max.br_pobeda<igraci[i].br_pobeda)
			max=igraci[i];

	}
	
	igrac globalMax[np];
	
	MPI_Gather (&max, 1,structIgrac,globalMax, np, structIgrac, 0, MPI_COMM_WORLD);
		
	if(id==0)
	{
		igrac temp;
		for (i = 0; i < np-1; i++)
		{
			for (j = i; j <np ; j++)
			{
				if(globalMax[i].br_pobeda<globalMax[j].br_pobeda)
				{
					temp = igraci[i];
					igraci[i] = igraci[j];
					igraci[j] = temp;
				}
			}		
		}
		printf("Kraj! Pobednici su\n");
		max = globalMax[0];
		printf("Igrac x=%d, y=%d sa %d pobeda\n", max.x,max.y, max.br_pobeda);
		for (i = 1; i < np; i++)
		{
			if(globalMax[i].br_pobeda==max.br_pobeda) printf("Igrac x=%d, y=%d sa %d pobeda\n", globalMax[i].x,globalMax[i].y, globalMax[i].br_pobeda);
		}
		
	}	
		
	MPI_Finalize();
}
	
	
	













