#ifndef KOSARKAS_H
#define KOSARKAS_H
#include "stat.h"
#include <string>
#include <boost/serialization/access.hpp>
using namespace std;
class Kosarkas{
	public:
		int id;
		string ime;
		int br_poena;
		int br_asistencija;
		int br_skokova;
		int br_utakmica;
	public:
		Kosarkas();
		Kosarkas(int id, string s){
			this->id=id;
			this->ime=s;
			this->br_poena=0;
			this->br_asistencija=0;
			this->br_skokova=0;
			this->br_utakmica=0;
			}
		void AddStat(Stat s){
			this->br_poena+=s.br_poena;
			this->br_asistencija+=s.br_asistencija;
			this->br_skokova+=s.br_skokova;
			this->br_utakmica++;
			}
		bool isPlayer(int id){ return (id==this->id)?true:false;}
		double countMvpRate(){
			double mvp=(double)(br_poena*2+br_asistencija*3+br_skokova*3)/(double)br_utakmica;
			return mvp;
			}
		bool operator > (Kosarkas k){
			return countMvpRate()>k.countMvpRate();
			}
		friend class boost::serialization::access;
		template <class Archive>
		void serialize(Archive &ar, unsigned int version){
			ar & this->id;
			ar & this->ime;
			ar & this->br_poena;
			ar & this->br_skokova;
			ar & this->br_asistencija;
			ar & this->br_utakmica;
			}
	};

#endif // KOSARKAS_H
