#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <boost/mpi/environment.hpp>
#include <boost/mpi/communicator.hpp>
#include <boost/mpi.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/string.hpp>
#include <vector>
#include "stat.h"
#include "kosarkas.h"
using namespace std;
using namespace boost::mpi;
vector<Kosarkas> UnesiKosarkase(){
	vector<Kosarkas> k;
	FILE *f=fopen("kosarkasi.txt","r");
	int n;
	fscanf(f,"%d",&n);
	int i;
	for (i=0;i<n;i++){
		char ime[30];
		int id;
		fscanf(f,"%d %s",&id,ime);
		string s(ime);
		Kosarkas k1(id,ime);
		k.push_back(k1);
		}
	fclose(f);
	return k;
	}
int NadjiIgraca(Kosarkas *k, int n, int id){
	int i=0;
	for (;i<n;i++){
		if (k[i].isPlayer(id)) return i; 
		}
	return -1;
	}
void UnesiStatistike(Kosarkas *k, int m){
	FILE *f = fopen("statistika.txt","r");
	int n;
	fscanf(f,"%d",&n);
	int i;
	for (i=0;i<n;i++){
		int id,poeni,asist,skok,i;
		fscanf(f,"%d%d%d%d",&id,&poeni,&asist,&skok);
		i=NadjiIgraca(k,m,id);
		if (i!=-1){
			Stat s(id,poeni,asist,skok);
			k[i].AddStat(s);
			}
		}
	}
int NadjiNajboljeg(Kosarkas *k, int n){
	int naj=0,i;
	for (i=1;i<n;i++){
		if (k[i]>k[naj]) naj=i;
		}
	return naj;
	}
main(int argc, char *argv[]){
	environment env(argc,argv);
	communicator world;
	vector<Kosarkas> k;
	int koKoliko;
	if (world.rank()==0){
		k=UnesiKosarkase();
		koKoliko=k.size()/world.size();
		}
	broadcast(world,koKoliko,0);
	Kosarkas k2[koKoliko];
	scatter(world,k,k2,koKoliko,0);
	UnesiStatistike(k2,koKoliko);
	int naj=NadjiNajboljeg(k2,koKoliko);
	Kosarkas najbolji[world.size()];
	gather(world,&k2[naj],1,najbolji,0);
	if (world.rank()==0){
		naj=NadjiNajboljeg(najbolji,world.size());
		printf("ID:%d\tIME:%s\tMvp_rate:%.2lf\n",najbolji[naj].id,najbolji[naj].ime.c_str(),najbolji[naj].countMvpRate());
		}
	}
