#include<mpi.h>
#include<stdio.h>
#include<stdlib.h>


double povrsina(double x1,double y1,double x2,double y2,double x3,double y3,double x4,double y4)
{
	
	return(1/2*(y1*(x4-x2)+y2*(x1-x3)+y3*(x2-x4)+y4*(x3-x1)));
}


int main(int argv,char*argc[])
{
	int np,id;
	
	MPI_Init(&argv,&argc);
	MPI_Comm_size(MPI_COMM_WORLD,&np);
	MPI_Comm_rank(MPI_COMM_WORLD,&id);
	MPI_Status status;
	int n;
	
	double *nizx;
	double *nizy;
	int deo;
	int i,j,k,l;
	if(id==0)
	{
		FILE *f = fopen("dat.txt","r");
		fscanf(f,"%d",&n);
		
		nizx=(double*)malloc(n*sizeof(double));
		nizy=(double*)malloc(n*sizeof(double));
		
		for (i = 0; i < n; i++)
		{
			fscanf(f,"%lf%lf",&nizx[i],&nizy[i]);
		}
		
		
		fclose(f);
	}
	
	
	MPI_Bcast(&n,1,MPI_INT,0,MPI_COMM_WORLD);
	
	if(id!=0)
	{
		nizx=(double*)malloc(n*sizeof(double));
		nizy=(double*)malloc(n*sizeof(double));
	}
	
	MPI_Bcast(nizx,n,MPI_INT,0,MPI_COMM_WORLD);
	MPI_Bcast(nizy,n,MPI_INT,0,MPI_COMM_WORLD);
	
	
	
	double max=-1000.0;
	double nizXMax[4];
	double nizyMax[4];
	
	
	
	//svako racuna kombinaciju za i+brp;
	for (i = id; i <n ; i+=np)
	{
		for (j = i+1; j <n ; j++)
		{
			for (l = j+1; l <n ; l++)
			{
				for (k = l+1; k<n ; k++)
				{
					
					if(i+4<n){ //da zadnja 4 ostanu takva..da mi ne ode sa 3elem{
					
						double tempovrsina=povrsina(nizx[i],nizy[i],nizx[j],nizy[j],nizx[l],nizy[l],nizx[k],nizy[k]);
						if(tempovrsina>max)
						{
							max=tempovrsina;
							
							//sacvuati sad koordianteL
							nizXMax[0]=nizx[i];
							nizXMax[1]=nizx[j];
							nizXMax[2]=nizx[l];
							nizXMax[3]=nizx[k];
							nizyMax[0]=nizy[i];
							nizyMax[1]=nizy[j];
							nizyMax[2]=nizy[l];
							nizyMax[3]=nizy[k];
							
						}
					}
				}
				
			}
			
		}
		
	}
	
	double konacnoMax;
	MPI_Reduce(&max,&konacnoMax,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD);// sad je u nula max povrsina
	
	
	
	double nizmaximuma[np];
	double nizKonacnihX[4*np];
	double nizKonacnihY[4*np];
	
	if(id!=0)
	{	
		MPI_Send(&max,1,MPI_DOUBLE,0,10,MPI_COMM_WORLD);
		MPI_Send(nizXMax,4,MPI_DOUBLE,0,15,MPI_COMM_WORLD);
		MPI_Send(nizyMax,4,MPI_DOUBLE,0,20,MPI_COMM_WORLD);
	}
	else
		{	
			//sacvuaj nulti element u nizKonacnih
			
			nizmaximuma[0]=max;
			for (i = 0; i < 4; i++)
			{
				nizKonacnihX[i]=nizXMax[i];
				nizKonacnihY[i]=nizyMax[i];
			}
			
			
			//sacuvaj ostale elemente u nizKonacnih
			for (i = 1; i < np; i++)
			{
				MPI_Recv(&nizmaximuma[i],1,MPI_DOUBLE,0,10,MPI_COMM_WORLD,&status);
				MPI_Recv(&nizKonacnihX[4*i],4,MPI_DOUBLE,0,15,MPI_COMM_WORLD,&status);
				MPI_Recv(&nizKonacnihY[4*i],4,MPI_DOUBLE,0,20,MPI_COMM_WORLD,&status);
			}
			
		}
	
	
	
	
	if(id==0)
	{
		
		printf("Najveca povrsina je : %lf",konacnoMax);
		
		for (i = 0; i < np; i++)
		{
			//ako bude vise cetvrougla sa ISTOM povrsinom stampa i njih
			if(konacnoMax==nizmaximuma[i])
			{
				printf("Tacke:\n");
				for (j = 0; j <4 ; j++)
				{
					printf("(%lf,%lf)\t",nizKonacnihX[i*4+j],nizKonacnihY[i*4+j]);
				}
				printf("\n");
			}
		}
		
		
	}
	
	MPI_Finalize();
	
}
