#include "Stat.h"
#include "Kosarkas.h"
#include <boost/mpi.hpp>
#include <boost/mpi/environment.hpp>
#include <boost/mpi/communicator.hpp>
#include <boost/mpi/collectives.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/vector.hpp>
#include <boost/serialization/string.hpp>
#include <iostream>
#include <sstream>
#include <vector>
#include <boost/array.hpp>



namespace mpi = boost::mpi;
using namespace std;

Kosarkas Najbolji(vector<Kosarkas> igraci){
	Kosarkas k=igraci[0];
	for(int i=1;i<igraci.size();i++){
			if(igraci[i]>k) k = igraci[i];
	}
	return k;
}


int main(int argc, char* argv[]){
	
	mpi::environment env(argc, argv);
	mpi::communicator world;
int n;	
vector<Kosarkas> igraci;
if(world.rank()==0){
	FILE *f = fopen("kosarkasi.dat","r");
	fscanf(f,"%d",&n);	
	//printf("%d\n",n);
	int i;
	char ime[40];
	int id;
	for(i=0;i<n;i++){
		fscanf(f,"%d%s",&id,ime);
		//printf("%d %s\n",id,ime);
		igraci.push_back(Kosarkas(id, ime));
		igraci[i].br_utakmica =0;
	}
	
	fclose(f);
}

vector<Stat> rezultati;
if(world.rank()==0){	
	FILE *g = fopen("statistika.dat","r");
	
	int br_poena;
	int br_asistencija;
	int br_skokova;
	fscanf(g,"%d%d%d%d",&id,&br_poena,&br_asistencija,&br_skokova);
	do{
		//printf("%d %d %d %d\n",id,br_poena,br_asistencija,br_skokova);
		//rezultati.push_back(Stat(id,br_poena,br_asistencija,br_skokova));
		for(int i=0;i<igraci.size();i++)
			if(igraci[i].isPlayer(i)==true){
				igraci[i].AddStat(br_poena,br_asistencija,br_skokova);
				igraci[i].br_utakmica = igraci[i].br_utakmica + 1;
			}
		fscanf(g,"%d%d%d%d",&id,&br_poena,&br_asistencija,&br_skokova);
	}while(!feof(g));
	
	fclose(g);	
}

int poproc = world.size() / n;
broadcast(world,poproc,0);
broadcast(world,igraci,poproc,0);

Kosarkas k = Najbolji(igraci);
Kosarkas* best = (Kosarkas*)malloc(world.size()*sizeof(Kosarkas));
gather(world, k,best,0);
if(world.rank() == 0){
	Kosarkas bestofthebest = Najbolji(best);
	streamstring ss;
	ss << bestofthebest.ime;
	cout << "Najbolji igrac je :\n"<< bestofthebest.id <<" "<<
	ss << " "<< bestofthebest.br_poena<<" " << bestofthebest.br_asistencija << " "
	<< bestofthebest.br_skokova << " "<<bestofthebest.br_utakmica	
	 <<endl;
}
}
